switch(forcerequiredaddon(Projectile_GravityRocket))
{
	case $Error::AddOn_Disabled: GravityRocketProjectile.uiName = "";
	case $Error::AddOn_NotFound: echo("\c2The RYNO VI requires the Gravity Rocket add-on!"); return;
}

exec("./homing.cs");

datablock AudioProfile(RYNO6_FireMusicSound)
{
	filename = "./Goober_Rock.wav";
	description = AudioCloseLooping3d;
	preload = true;
};

datablock ParticleData(RYNO6_FlashParticle)
{
	dragCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 1;
	constantAcceleration = 0;
	lifetimeMS = 100;
	lifetimeVarianceMS = 99;
	textureName = "base/data/particles/star1";
	spinSpeed= 10;
	spinRandomMin= -500;
	spinRandomMax= 500;
	useInvAlpha = false;
	colors[0] = "1 0 0 1";
	colors[1] = "1 1 1 1";
	colors[2] = "0 0 1 1";
	sizes[0] = 0.5;
	sizes[1] = 0.4;
	sizes[2] = 0.3;
};
datablock ParticleEmitterData(RYNO6_FlashEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.25;
   velocityVariance = 0;
   ejectionOffset = 0.35;
   thetaMin = 85;
   thetaMax = 105;
   phiReferenceVel = 0;
   phiVariance = 360;
   overrideAdvance = false;
   particles = RYNO6_FlashParticle;
};

datablock ParticleData(RYNO6_SmokeParticle)
{
	dragCoefficient = 5;
	gravityCoefficient = -0.25;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0;
	lifetimeMS = 500;
	lifetimeVarianceMS = 100;
	textureName = "base/data/particles/cloud";
	spinSpeed = 10;
	spinRandomMin = -500;
	spinRandomMax = 500;
	useInvAlpha = false;
	colors[0] = "0.3 0 0 0.5";
	colors[1] = "0.3 0.3 0.3 0.5";
	colors[2] = "0 0 0.3 0.5";
	sizes[0] = 0.15;
	sizes[1] = 0.15;
	sizes[2] = 0.15;
};
datablock ParticleEmitterData(RYNO6_SmokeEmitter : RYNO56_FlashEmitter)
{
	ejectionPeriodMS = 3;
	particles = RYNO6_SmokeParticle;
};

datablock ParticleData(RYNO6_SmallBullet_Particle)
{
	dragCoefficient = 3;
	gravityCoefficient = -0.5;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 25;
	lifetimeVarianceMS = 15;
	textureName = "base/data/particles/dot";
	spinSpeed = 10;
	spinRandomMin = -500;
	spinRandomMax = 500;
	useInvAlpha = false;
	colors[0] = "0 1 1 1";
	colors[1] = "0 0.5 0.8 0.9";
	sizes[0] = 0.3;
	sizes[1] = 0.1;
};
datablock ParticleEmitterData(RYNO6_SmallBulletEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 1;
	velocityVariance = 1;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = RYNO6_SmallBullet_Particle;
};

datablock ParticleData(RYNO6_RocketTrail_Particle)
{
	dragCoefficient = 5;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 1000;
	lifetimeVarianceMS = 100;
	textureName = "base/data/particles/cloud";
	spinSpeed = 10;
	spinRandomMin = -200;
	spinRandomMax = 200;
	useInvAlpha = true;
	colors[0] = "1 0 0 0.8";
	colors[1] = "1 1 1 0.8";
	colors[2] = "0 0 1 0.8";
	colors[3] = "0.35 0.32 0.3 0";
	sizes[0] = 0.3;
	sizes[1] = 0.5;
	sizes[2] = 0.6;
	sizes[3] = 0.8;
	times[0] = 0;
	times[1] = 0.2;
	times[2] = 0.4;
	times[3] = 1;
};
datablock ParticleEmitterData(RYNO6_RocketTrailEmitter)
{
	ejectionPeriodMS = 10;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0;
	ejectionOffset = 0.2;
	thetaMin = 135;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = RYNO6_RocketTrail_Particle;
};

datablock ParticleData(RYNO6_SmallExplosionParticle)
{
   dragCoefficient = 8;
   windCoefficient = 0;
   gravityCoefficient = -0.2;
   inheritedVelFactor = 0;
   constantAcceleration = 0;
   lifetimeMS = 50;
   lifetimeVarianceMS = 35;
   spinSpeed = 10;
   spinRandomMin = -500;
   spinRandomMax = 500;
   useInvAlpha = false;
   textureName = "base/data/particles/cloud";
   colors[0] = "1 0.7 0.1 0.8";
   colors[1] = "1 1 0.5 0";
   sizes[0] = 1;
   sizes[1] = 0;
   times[0] = 0;
   times[1] = 1;
};
datablock ParticleEmitterData(RYNO6_SmallExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0;
   thetaMin = 0;
   thetaMax = 90;
   phiReferenceVel = 0;
   phiVariance = 360;
   particles = RYNO6_SmallExplosionParticle;
   lifetimeMS = 50;
   lifetimeVarianceMS = 0;
};

datablock ExplosionData(RYNO6_SmallExplosion)
{
   //soundProfile = ;
   faceViewer = true;
   particleEmitter = RYNO6_SmallExplosionEmitter;
   particleDensity = 50;
   particleRadius = 0.5;
   explosionScale = "1 1 1";
   playSpeed = 1;
   emitter[0] = RYNO6_SmallExplosionEmitter;
   lifetimeMS = 50;
   lifetimeVariance = 0;
   shakeCamera = true;
   cameraShakeFalloff = 11;
   camShakeFreq = "10 10 10";
   camShakeAmp = "2 2 2";
   camShakeDuration = 0.5;
   camShakeRadius = 10;
   camShakeFalloff = 10;
   lightStartRadius = 1;
   lightEndRadius = 3;
   lightStartColor = "1 1 1";
   lightEndColor = "1 1 0";
};

AddDamageType("RynoVI", '<bitmap:Add-Ons/Weapon_RYNO_VI/CI_RYNO6> %1', '%2 <bitmap:Add-Ons/Weapon_RYNO_VI/CI_RYNO6> %1', 1, 1);
AddDamageType("RynoVIradius", '<bitmap:Add-Ons/Weapon_RYNO_VI/CI_RYNO6> %1', '%2 <bitmap:Add-Ons/Weapon_RYNO_VI/CI_RYNO6> %1', 1, 0);

datablock ExplosionData(RYNO6_RocketExplosion : GravityRocketExplosion)
{
	damageRadius = 15;
	radiusDamage = 100;
	impulseRadius = 20;
	impulseForce = 8000;
	playerBurnTime = 0;
};

datablock ProjectileData(RYNO6_SmallProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage = 50;
	directDamageType = $DamageType::RynoVI;
	radiusDamageType = $DamageType::RynoVIradius;

	brickExplosionRadius = 2;
	brickExplosionImpact = true;
	brickExplosionForce  = 50;
	brickExplosionMaxVolume = 50;
	brickExplosionMaxVolumeFloating = 80;

	impactImpulse = 1000;
	verticalImpulse = 1000;
	explosion = RYNO6_SmallExplosion;
	particleEmitter = RYNO6_SmallBulletEmitter;

	muzzleVelocity = 125;
	velInheritFactor = 0;

	armingDelay = 0;
	lifetime = 4000;
	fadeDelay = 3500;
	bounceElasticity = 0.5;
	bounceFriction = 0.20;
	isBallistic = false;
	gravityMod = 0;

	hasLight = true;
	lightRadius = 2;
	lightColor = "1 0 0";
};

datablock ProjectileData(RYNO6_RocketProjectile)
{
	projectileShapeName = "./RYNO6missile.dts";
	directDamage = 100;
	directDamageType = $DamageType::RynoVI;
	radiusDamageType = $DamageType::RynoVIradius;

	brickExplosionRadius = 5;
	brickExplosionImpact = true;
	brickExplosionForce  = 70;
	brickExplosionMaxVolume = 65;
	brickExplosionMaxVolumeFloating = 100;

	impactImpulse = 9000;
	verticalImpulse = 9000;
	explosion = RYNO6_RocketExplosion;
	particleEmitter = RYNO6_RocketTrailEmitter;

	muzzleVelocity = 125;
	velInheritFactor = 0;

	armingDelay = 0;
	lifetime = 5000;
	fadeDelay = 5000;
	bounceElasticity = 0.5;
	bounceFriction = 0.20;
	isBallistic = false;
	gravityMod = 0;
	hasLight = true;
	lightRadius = 2;
	lightColor = "1 0 0";
};

datablock ItemData(RYNO6_Item)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./RYNO6.dts";
	rotate = false;
	mass = 10;
	density = 1;
	elasticity = 0;
	friction = 1;
	emap = true;

	uiName = "RYNO VI";
	iconName = "./Icon_RYNO_VI";
	doColorShift = true;
	colorShiftColor = "1 0 0 1";

	image = RYNO6_Image;
	canDrop = true;
};

datablock ShapeBaseImageData(RYNO6_Image)
{
	shapeFile = "./RYNO6.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = "0.8 0.8 -0.5";
	rotation = "0 0 0";

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = RYNO6_Item;
	ammo = " ";
	projectile = RYNO6_SmallProjectile;
	projectileType = Projectile;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = RYNO6_Item.colorShiftColor;

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.1;
	stateTransitionOnTimeout[0]    = "Ready";
	stateSound[0]                  = weaponSwitchSound;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire";
	stateAllowImageChange[1]       = true;
	stateSequence[1]               = "Idle";

	stateName[2]                   = "Fire";
	stateTransitionOnTimeout[2]    = "Fire";
	stateTransitionOnTriggerUp[2]  = "Smoke";
	stateTimeoutValue[2]           = 0.01;
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = false;
	stateSequence[2]               = "Fire";
	stateScript[2]                 = "onFire";
	stateWaitForTimeout[2]         = true;
	stateEmitter[2]                = RYNO6_FlashEmitter;
	stateEmitterTime[2]            = 0.01;
	stateEmitterNode[2]            = "muzzleNode";
	stateSound[2]                  = RYNO6_FireMusicSound;

	stateName[3]                   = "Smoke";
	stateEmitter[3]                = RYNO6_SmokeEmitter;
	stateEmitterTime[3]            = 0.1;
	stateEmitterNode[3]            = "muzzleNode";
	stateTimeoutValue[3]           = 0.1;
	stateTransitionOnTimeout[3]    = "Ready";
	stateSequence[3]               = "Slow";
};

function RYNO6_Image::onFire(%this,%obj,%slot)
{
	if(!%obj.lastRYNO6rocket)
	{
		%obj.lastRYNO6rocket = getSimTime();
	}
	%spread = 0.15;
	%vector = %obj.getMuzzleVector(%slot);
	%vector = VectorScale(%vector, 130);
	%x = (getRandom() - 0.5) * %spread;
	%y = (getRandom() - 0.5) * %spread;
	%z = (getRandom() - 0.5) * %spread;
	%mat = MatrixCreateFromEuler(%x SPC %y SPC %z);
	%velocity = MatrixMulVector(%mat, %vector);
	%p = new projectile()
	{
		dataBlock = RYNO6_SmallProjectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	if((%obj.lastRYNO6rocket + 250) <= getSimTime())
	{
		%obj.lastRYNO6rocket = getSimTime();
		new projectile()
		{
			dataBlock = RYNO6_RocketProjectile;
			initialVelocity = vectorScale(vectorNormalize(%velocity), 50);
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
	}
	MissionCleanup.add(%p);
	return %p;
}